Imports System.ServiceProcess
Imports System.IO
Imports System.Text

Public Class AppMonitorService
  Inherits System.ServiceProcess.ServiceBase

  ' Monitor log file & path
  Private strLogDest As String

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        ' This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserService overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    ' NOTE: The following procedure is required by the Component Designer
    ' It can be modified using the Component Designer.  Do not modify it
    ' using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
'
'AppMonitorService
'
Me.AutoLog = False
Me.CanPauseAndContinue = True
Me.CanShutdown = True
Me.ServiceName = "AppMonitorService"

    End Sub

#End Region
  ' The main entry point for the process
  <MTAThread()> _
  Shared Sub Main()
    ' This is the main thread that gets loaded when all the services
    ' listed in the service directory get instantiated.
    Dim ServicesToRun() As System.ServiceProcess.ServiceBase

    ' Setup the service to run
    ServicesToRun = New System.ServiceProcess.ServiceBase() _
                    {New AppMonitorService}
                    System.ServiceProcess.ServiceBase.Run(ServicesToRun)
  End Sub

  Protected Overrides Sub OnStart(ByVal args() As String)
    ' Add code here to execute when service first starts up. An example
    ' could be to spin off a thread with a timer that does stuff
    ' in the background.

    ' See if the path to the log file was sent as an argument
    If (args.Length = 0) Then
      strLogDest = "\Monitor.txt"
    Else
      strLogDest = args(0).ToString
    End If
    WriteAuditEntry(Now.ToString + ": Service Started")
  End Sub

  Protected Overrides Sub OnStop()
    ' Add code here to perform any tear-down necessary 
    ' to stop your service.
    WriteAuditEntry(Now.ToString + ": Service Stopped")
  End Sub

  Protected Overrides Sub OnPause()
    ' Add code here to perform work needed to 
    ' pause the service
    WriteAuditEntry(Now.ToString + ": Service Paused")
  End Sub

  Protected Overrides Sub OnContinue()
    ' Add code here to perform work needed to 
    ' resume the service
    WriteAuditEntry(Now.ToString + ": Service Resumed")
  End Sub

  Protected Overrides Sub OnCustomCommand(ByVal iCommand As Integer)
    ' Add code here to perform work needed to 
    ' handle a custom command to the service from
    ' an external application.

    ' Determine the command and log the event
    Select Case iCommand
      Case MonitorWrapper.MonitorWrapper.MonitorCode.MON_GATE_A_OPEN
        WriteAuditEntry(Now.ToString + ": Gate A Opened")
      Case MonitorWrapper.MonitorWrapper.MonitorCode.MON_GATE_B_OPEN
        WriteAuditEntry(Now.ToString + ": Gate B Opened")
      Case MonitorWrapper.MonitorWrapper.MonitorCode.MON_FIREALARM_A
        WriteAuditEntry(Now.ToString + _
                        ": Zone A Fire Alarm Activated")
      Case MonitorWrapper.MonitorWrapper.MonitorCode.MON_SPRINKLER_A
        WriteAuditEntry(Now.ToString + _
                        ": Sprinkler System Zone A Activated")
      Case Else
        WriteAuditEntry(Now.ToString + _
                        ": UNDEFINED COMMAND RECEIVED (" + _
                        iCommand.ToString + ")")
    End Select
  End Sub

  Private Sub WriteAuditEntry(ByVal strMsg As String)
    Dim sw As StreamWriter

    If File.Exists(strLogDest) Then
      sw = New StreamWriter(strLogDest, True)
    Else
      sw = File.CreateText(strLogDest)
    End If
    sw.WriteLine(strMsg)
    sw.Close()
  End Sub
End Class
